#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n ;
    cin >> n ;
    long long x,y ;
    long long mxx,mxy,mnx,mny ;
    cin >> x >> y ;
    mxx=x ;
    mnx=x ;
    mxy=y ;
    mny=y ;
    vector<long long>xn ;
    vector<long long>yn ;
    xn.push_back(x) ;
    yn.push_back(y) ;
    cout << 0 << endl ;
    for(int i=1 ; i<n ; i++){
        cin >> x >> y ;
        xn.push_back(x) ;
        yn.push_back(y) ;
        mxx=max(mxx,x) ;
        mnx=min(mnx,x) ;
        mxy=max(mxy,y) ;
        mny=min(mny,y) ;
        long long r1=0 , r2=0 ,r3=0,r4=0 ;
        for(int j=0 ; j<=i ; j++){
            r1+=abs(mxx-xn[j])*abs(mxy-yn[j]) ;
            r2+=abs(mxx-xn[j])*abs(mny-yn[j]) ;
            r3+=abs(mnx-xn[j])*abs(mxy-yn[j]) ;
            r4+=abs(mnx-xn[j])*abs(mny-yn[j]) ;
        }
        cout << max(max(r1,r2),max(r3,r4)) << endl  ;
    }
    return 0;
}